/**************************************************************************\
*									   *
*   LNKV.C   -	 unido X-Mac, globale Variable Linker			   *
*									   *
*					Michael	Roehner, unido ChiPSy	   *
*									   *
\**************************************************************************/





/*							       Includes	  */
/**************************************************************************/

#include <stdio.h>			/* Standardausgabe benutzt	  */
#include <string.h>			/* Stringfunktionen benutzt	  */
#include "all.h"			/* allgemeine Festlegungen	  */
#include "lnk.h"			/* Definitionen	fuer Linker	  */
#include "rel.h"			/* Aufbau REL			  */
#include "uti.h"




/*								Globals	  */
/**************************************************************************/

char high[] = {	HIGH , 0 };   /* Symbol	fuer hoechsten Eintrag/Wert	  */

char	   *argbuf;	      /* Zeiger	auf Anfang Argumentenbuffer	  */
char	   *myargv[ARGMAX];   /* "mein"	argv[]				  */
int	    myargc;	      /* "mein"	argc				  */
char	    argfn[FNSIZE+1];  /* Name der Linkkommandodatei LNK		  */
FILE	   *argfile;	      /* LNK-Datei				  */

BOOLEAN	    bin;	 /* TRUE = BIN-Format				  */
BOOLEAN	    data;	 /* TRUE = Datensegment	erzeugen		  */
BOOLEAN	    monitor;	 /* TRUE = Protokoll				  */

char	   *cbuffer;	 /* Zeiger auf Anfang Codesegmentbuffer		  */
char	   *cbnext;	 /* Zeiger auf naechstes Byte Codesegmentbuffer	  */

char	   *dbuffer;	 /* Zeiger auf Anfang Datensegmentbuffer	  */
char	   *dbnext;	 /* Zeiger auf naechstes Byte Datensegmentbuffer  */

char	   *snext;	 /* Zeiger auf naechsten Eintrag in Symboltabelle */
unsigned    sfree;	 /* Index auf Liste wieder freier Eintraege in "  */

char	   *crstart;	 /* Zeiger Anfang Wertebuffer externe Referenzen  */
char	   *crnext;	 /* Zeiger auf naechstes Byte im  "  "	"	  */
char	   *crend;	 /* Phase 2: Zeiger hinter letztes Byte	im  " "	" */

char	   *epfirst;	 /* Zeiger auf Eintrag erster Einsprungpunkt	  */
char	   *epnext;	 /* Zeiger auf Eintrag naechster Einsprungpunkt	  */

char	   *xrfirst;	 /* Zeiger auf Eintrag erste externe Referenz	  */
char	   *xrnext;	 /* Zeiger auf Eintrag naechste	externe	Referenz  */

unsigned    loading;	 /* was	gerade geladen wird (CSEGBIT/DSEGBIT)	  */
unsigned    cbase;	 /* Basisadresse Codesegment			  */
unsigned    cloc;	 /* Positionszaehler Code Gesamtprogramm	  */
unsigned    cmod;	 /* Position Codeanfang	aktuelles Modul		  */
unsigned    csize;	 /* Groesse Codebereich	insgesamt		  */
unsigned    dbase;	 /* Basisadresse Datensegment			  */
unsigned    dloc;	 /* Positionszaehler Daten Gesamtprogramm	  */
unsigned    dmod;	 /* Position Datenanfang aktuelles Modul	  */
unsigned    dsize;	 /* Groesse Datenbereich insgesamt		  */

char	    modname[MAXSYM+1];/* Name des aktuellen Moduls		  */
char	    infn[FNSIZE+1];   /* Name der Eingabedatei			  */
char	    outfn[FNSIZE+1];  /* Name der Ausgabedatei			  */
FILE	   *outfile;	      /* Ausgabedatei				  */
unsigned    ref;	      /* Bezug auf programmrelativen Eintrag	  */
unsigned    xrplus;	      /* Offset-Wert fuer naechste ext.	Referenz  */
unsigned    start;	      /* Programmstartadresse			  */



/* Ende	von LNKV.C */
