/**************************************************************************\
*									   *
*   REL.H   -	 unido X-Mac, Definitionen Microsoft-REL-Format		   *
*									   *
*					Michael	Roehner, unido ChiPSy	   *
*									   *
\**************************************************************************/





/*				      Typcodes fuer die	einzelnen Items	  */
/**************************************************************************/

#define	ABS	    0	      /* absolut				  */
#define	PREL	    1	      /* programmrelativ			  */
#define	DREL	    2	      /* datenrelativ				  */
#define	CREL	    3	      /* commonrelativ				  */

#define	ENAME	    4	      /* Name des Eintrags			  */
#define	CNAME	    5	      /* Name des Commonblocks			  */
#define	PNAME	    6	      /* Programmname				  */
#define	LNAME	    7	      /* Bibliotheksname			  */
#define	EXT	    8	      /* Extension Link-Item			  */

#define	CSIZE	    9	      /* Groesse und Name Common		  */
#define	XCHAIN	   10	      /* Kette externer	Referenzen: Head und Name */
#define	EPOINT	   11	      /* Ort eines Einsprungpunkts und Name	  */

#define	XMOFF	   12	      /* extern	- Offset			  */
#define	XPOFF	   13	      /* extern	+ Offset			  */
#define	DSIZE	   14	      /* Groesse des Datenbereichs		  */
#define	SETLC	   15	      /* Positionszaehler fuer das Laden setzen	  */
#define	CHAIN	   16	      /* Kettungsadresse			  */
#define	PSIZE	   17	      /* Groesse des Codes			  */
#define	EPROG	   18	      /* Ende des Programms			  */
#define	EFILE	   19	      /* Ende der Datei				  */

#define ABSTOK 	   0	      /* or-Maske fuer absolute items		  */
#define ABSTOK_N   0x80       /* and-Maske fuer absolute items		  */
#define RELTOK     0x80	      /* or-Maske fuer relative items		  */
#define RELTOK_N   0xc0	      /* and-Maske fuer relative items		  */
#define SPECTOK    0xc0	      /* or-Maske fuer relative items		  */
#define SPECTOK_N  0xc0	      /* and-Maske fuer relative items		  */


/*							      Sonstiges	  */
/**************************************************************************/

#define	MAXSYM	    15	      /* Maximale Symbollaenge in einer	REL-Datei */
#define	ONES	    (-1)      /* alle Bits gesetzt !			  */

int	 getrel __ARGS((void));
int	 getword __ARGS((void));
int	 getsym __ARGS((void));
BOOLEAN	 putrel __ARGS((void));
BOOLEAN  putbyte __ARGS((int));
BOOLEAN  putword __ARGS((void));
BOOLEAN	 putsym __ARGS((void));
void	 inrelinit __ARGS((void));
void	 outrelinit __ARGS((void));

/* Ende	von REL.H */
